import Calculator from "../solution_29.js";
import assert from "assert";

describe("\n\nSolution_29", () => {
  let calc = new Calculator();

  it(`should return 10 for calc.calculate("3 + 7")`, () => {
    assert.deepEqual(calc.calculate("3 + 7"), 10);
  });

  it(`should return 17 for calc.calculate("5 + 12")`, () => {
    assert.deepEqual(calc.calculate("5 + 12"), 17);
  });

  it(`should return 15 for calc.addMethod("*", (a, b) => a * b); calc.calculate("5 * 3")`, () => {
    calc.addMethod("*", (a, b) => a * b);
    assert.deepEqual(calc.calculate("5 * 3"), 15);
  });

  it(`should return 5 for calc.addMethod("/", (a, b) => a / b); calc.calculate("20 / 4")`, () => {
    calc.addMethod("/", (a, b) => a / b);
    assert.deepEqual(calc.calculate("20 / 4"), 5);
  });

  it(`should return 16 for calc.addMethod("**", (a, b) => a ** b); calc.calculate("2 ** 4")`, () => {
    calc.addMethod("**", (a, b) => a ** b);
    assert.deepEqual(calc.calculate("2 ** 4"), 16);
  });

  it(`should return 1 for calc.addMethod("mod", (a, b) => a % b); calc.calculate("10 mod 3")`, () => {
    calc.addMethod("mod", (a, b) => a % b);
    assert.deepEqual(calc.calculate("10 mod 3"), 1);
  });

  let characters =
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
  let charactersLength = characters.length;

  for (let k = 0; k <= 10; k++) {
    let offset = Math.floor(Math.random() * charactersLength);

    let op_name = characters.charAt(offset);

    let operators = "+-*/%";
    let operation = operators.charAt(
      Math.floor(Math.random() * operators.length)
    );

    let proc;
    let proc_str;
    switch (operation) {
      case "+":
        proc = (a, b) => a + b + offset;
        proc_str = `(a,b) => a + b + ${offset}`;
        break;
      case "-":
        proc = (a, b) => a - b - offset;
        proc_str = `(a,b) =>  a - b - ${offset}`;
        break;
      case "*":
        proc = (a, b) => a * b * offset;
        proc_str = `(a,b) => a * b * ${offset}`;
        break;
      case "/":
        proc = (a, b) => a / b / offset;
        proc_str = `(a,b) => a / b / ${offset}`;
        break;
      case "%":
        proc = (a, b) => (a % b) % offset;
        proc_str = `(a,b) => a % b % ${offset}`;
        break;
    }

    let a = Math.floor(Math.random() * 10);
    let b = Math.floor(Math.random() * 10);

    it(`should return ${proc(
      a,
      b
    )} for calc.addMethod("${op_name}", ${proc_str}); calc.calculate("${a} ${op_name} ${b}")`, () => {
      calc.addMethod(op_name, proc);
      assert.deepEqual(calc.calculate(`${a} ${op_name} ${b}`), proc(a, b));
    });
  }
});
